function [MV,b,MyLAMBDA]=problem1(n)
%[MV,b]=problem1(n) 
%   Defines the right-hand side vector b of the linear problem A*x=b,
%   and defines the function that performes the multiplication with 
%   the matrix A, i.e., the matrix-vector multiplication.
%   MV is the handle of this function.
%   n is a parameter that determines the dimension of A.
%
%Note that size(b,1) will reveal the dimension of the problem.
%
%[MV,b,Lambda]=problem1(n)
%   Lambda is an size(b,1) x 1 array of eigenvalues of A
%
%Note: a function-handle is used to avoid repeatedly defining the matrix A.
%   See MATLAB's documentation "Using Handles to Store Function Parameters".
%
%
% See also ReadMe, problem1b, problem1c

  Lambda=[1,100];
  h=(Lambda(2)-Lambda(1))/(n-1); 

  MyLAMBDA=(Lambda(1):h:Lambda(2))';
 
  A=spdiags(MyLAMBDA,0,n,n);
  
  MV=@MyMV;

  function c=MyMV(u,flag)
      if nargin==1, c=A*u; else, c=A'*u; end
  end
  
  x=ones(n,1);
  b=MyMV(x);


end