function [MV,b,MyLAMBDA]=problem2(n)
%[MV,b]=problem2(n) 
%   Defines the right-hand side vector b of the linear problem A*x=b, 
%   and defines the function that performes the multiplication with the 
%   matrix A, i.e., the matrix-vector multiplication.
%   MV is the handle of this function.
%   n is a parameter that determines the dimension of A.
%
%[MV,b,Lambda]=problem2(n)
%   Lambda is an size(b,1) x 1 array of eigenvalues of A
%  
%
%  See also   problem1 (a-c)
%

% A is a rotation of a diagonal matrix: A=Q'*D*Q with D diagonal, Q unitary


  Lambda=[1,n];
  h=(Lambda(2)-Lambda(1))/(n-1); 

  MyLAMBDA=(Lambda(1):h:Lambda(2))';
   
  shift=MyLAMBDA(3,1)-1.0e-10;
  D=spdiags(MyLAMBDA-shift,0,n,n);
  
  %%% produce a random orthonormal matrix V by
  V=rand(n,1); 
  %%% then orthonormalise V
  [V,R]=qr(V,0);
  
  function c=MyMV(u)
      %%% diagonal matrices may give the wrong impression 
      %%% of the effects of rounding errors: rotate the
      %%% diagonal using Householder reflections
     c=u;
     c=c-V*(V'*(2*c));
     c=D*c; 
     c=c-V*(V'*(2*c));  
  end
  
  MV=@MyMV;
  
  x=ones(n,1);
  b=MyMV(x);

end