function myplot(A,b,x,hist,t,NoMV,str,color)

global MyLEGEND MyHANDLE MyCOLOR

if nargin==0, 
  %%% initialise picture
  MyLEGEND=''; MyHANDLE=[]; MyCOLOR=1;
  fprintf('\n======================================================\n')
  return, 
end

if nargin==2, 
  %%% Put legends, title and labels in the picture
  legend(MyHANDLE,MyLEGEND)
  n=size(b,1);
  title(sprintf('Convergence history linear solvers. A is %d x %d',n,n))
  xlabel('# MV')
  ylabel('log_{10}||r_k||_2') 
  zoom on
  return, 
end

  %%% dimension problem
  n=size(b,1);

  %%% compute true residual norm 
  if IsMatrix(A)
    nr=norm(b-A*x,2); 
  else
    nr=norm(b-feval(A,x),2); 
  end
  %%% number of iteration steps
  l=length(hist)-1;
  J=0:l;
  
  %%% string to display statistics
  fstr='%s\n';
  fstr=[fstr,'dimension problem: %d\n'];
  fstr=[fstr,'#iteration steps: %d, #MV: %d\n'];
  fstr=[fstr,'time: %9.3g sec\n'];
  fstr=[fstr,'true (predicted) residual accuracy: %7.3g  (%7.3g)\n\n'];
  fprintf(1,fstr,str,n,l,NoMV,t,nr,hist(1,l+1));
  
  if nargin==7, 
    COLOR=['k';'b';'r';'g';'y';'m';'c']; nC=size(COLOR,1);
     color=COLOR(MyCOLOR,:); 
     MyCOLOR=MyCOLOR+1; if MyCOLOR>nC, MyCOLOR=1; end
  end
  
  %%% find handle for the plots in legend
  hc=plot(J,log10(hist),[color,'-*']); hold on
  plot(J,log10(0*J+nr),[color,':']), drawnow, pause(0.01);
  
  %%% legend for the plots
  MyLEGEND=strvcat(MyLEGEND,str);
  MyHANDLE=[MyHANDLE;hc];

return
